#include <compile.h>
#include <parse.h>
extern int pv;

int parse(void){
if( expr() ){
return 1; }
if( tok == tkEOF ){
mylex();
return 1; }
return 0;
}
int start(void){
zpush(tkBOT);
return 1;
}
int expr(void){
if( start() ){
commit(term());
commit(exprs());
return 1; }
return 0;
}
int exprs(void){
loop:
if( lop() ){
commit(term());
goto loop;}
zclean();
return 1;
}
int lop(void){
if( tok == tkAND ){
zop(tok);
mylex();
return 1; }
if( tok == tkOR ){
zop(tok);
mylex();
return 1; }
return 0;
}
int term(void){
if( tok == tkIDEN ){
dovar(tokstring);
mylex();
commit(bop());
return 1; }
if( tok == tkLPAREN ){
mylex();
commit(expr());
expect(tkRPAREN, "missing tkRPAREN");
mylex();
return 1; }
return 0;
}
int bop(void){
switch(tok){
case tkEQ:
zop(tok);
mylex();
commit(value());
return 1;
case tkNE:
zop(tok);
mylex();
commit(value());
return 1;
case tkGE:
zop(tok);
mylex();
commit(value());
return 1;
case tkLT:
zop(tok);
mylex();
commit(value());
return 1;
case tkGT:
zop(tok);
mylex();
commit(value());
return 1;
case tkLIKE:
zop(tok);
mylex();
expect(tkSTRING, "missing tkSTRING");
dostring(tokstring);
mylex();
return 1;
case tkBETWEEN:
zop(tok);
mylex();
commit(value());
expect(tkAND, "missing tkAND");
mylex();
commit(value());
dobetween();
return 1;
case tkIN:
zop(tok);
mylex();
commit(vlist());
return 1;
case tkIS:
zop(tok);
mylex();
commit(isnull());
return 1;
case tkNOT:
mylex();
commit(neg());
return 1;
}
return 0;
}
int neg(void){
switch(tok){
case tkLIKE:
zop(tkNLIKE);
mylex();
expect(tkSTRING, "missing tkSTRING");
dostring(tokstring);
mylex();
return 1;
case tkBETWEEN:
zop(tkNBET);
mylex();
commit(value());
expect(tkAND, "missing tkAND");
mylex();
commit(value());
dobetween();
return 1;
case tkIN:
zop(tkNIN);
mylex();
commit(vlist());
return 1;
}
return 0;
}
int value(void){
if( tok == tkNUMBER ){
donum(tokstring);
mylex();
return 1; }
if( tok == tkSTRING ){
dostring(tokstring);
mylex();
return 1; }
return 0;
}
int isnull(void){
if( tok == tkNULL ){
dostring('null');
mylex();
return 1; }
if( tok == tkNOT ){
mylex();
expect(tkNULL, "missing tkNULL");
dostring('not null');
mylex();
return 1; }
return 0;
}
int vlist(void){
if( tok == tkLPAREN ){
ypush(MARK);
mylex();
commit(value());
commit(values());
return 1; }
return 0;
}
int values(void){
loop:
if( tok == tkCOMMA ){
mylex();
commit(value());
goto loop;}
if( tok == tkRPAREN ){
dolist();
mylex();
return 1; }
return 0;
}
